package jalview.ws2.actions.annotation;

import java.util.List;
import java.util.Map;

import jalview.api.FeatureColourI;
import jalview.datamodel.AlignmentAnnotation;
import jalview.datamodel.features.FeatureMatcherSetI;

/**
 * A simple data container storing the output of annotation tasks. The object is
 * constructed on {@link AnnotationTask} completion and passed to an appropriate
 * handler.
 * 
 * @author mmwarowny
 *
 */
public class AnnotationResult
{
  final List<AlignmentAnnotation> annotations;

  final boolean hasFeatures;

  final Map<String, FeatureColourI> featureColours;

  final Map<String, FeatureMatcherSetI> featureFilters;

  public AnnotationResult(List<AlignmentAnnotation> annotations, boolean hasFeatures,
      Map<String, FeatureColourI> featureColours, Map<String, FeatureMatcherSetI> featureFilters)
  {
    this.annotations = annotations;
    this.hasFeatures = hasFeatures;
    this.featureColours = featureColours;
    this.featureFilters = featureFilters;
  }

  public List<AlignmentAnnotation> getAnnotations()
  {
    return annotations;
  }
  
  public boolean getHasFeatures()
  {
    return hasFeatures;
  }

  public Map<String, FeatureColourI> getFeatureColours()
  {
    return featureColours;
  }

  public Map<String, FeatureMatcherSetI> getFeatureFilters()
  {
    return featureFilters;
  }
}
